Subject: Re: bug#11774: org-mode causes undo boundaries to be lost

From: Toby Cubitt <[email-masked]>
Date: Mon, 25 Jun 2012 13:35:29 +0200

On Sun, Jun 24, 2012 at 11:52:41PM +0200, Toby Cubitt wrote:
> On Sun, Jun 24, 2012 at 11:39:08PM +0200, Bastien wrote:
> > Hi Toby,
> > 
> > Toby Cubitt <[email-masked]> writes:
> > 
> > > For some unknown reason, org-mode is causing the undo boundary between
> > > the (2 . 4) and (1 . 2) entries to be removed from `buffer-undo-list'.
> > 
> > Can you try again with
> > 
> >   (setq org-self-insert-cluster-for-undo nil)
> > 
> > and report?
> 
> Yup, that fixes the problem.
> 
> I don't fully understand the purpose of
> `org-self-insert-cluster-for-undo', given that the Emacs command loop
> already groups consecutive undo entries together, but presumably it
> enables a more aggressive form of clustering.
>
[snip]
>
> I could try to work around this in undo-tree-mode, but it seems to me
> that org-mode shouldn't be throwing away an undo boundary that comes
> before an entry which definitely shouldn't be clustered with anything
> (namely the undo-tree-canary symbol, which is meaningless to org-mode).

I've now added a work-around for this in undo-tree-mode (currently only
in git, but I'll push to ELPA once it's sufficiently tested).

I'm still not entirely convinced that the boundary discarding logic in
org-self-insert-command is correct. For example, if I do the following:

1. Type some text at some location in an org-mode buffer
2. Move to another location very far away
   (without invoking any commands other than point motion)
3. Type some more text

then org-self-insert-cluster-for-undo collapses the undo changesets for
these two changes into one. Undoing then reverts both sets of changes at
once, even though those changes might be so far apart that they aren't
both visible at the same time in the buffer.

That seems very undesirable to me.

But as I can work around it in undo-tree-mode, I'll leave it up to
Bastien to decide whether or not this feature needs reworking in
org-mode.

Best,
Toby
-- 
Dr T. S. Cubitt
Mathematics and Quantum Information group
Department of Mathematics
Complutense University
Madrid, Spain

email: [email-masked]
web:   www.dr-qubit.org